org.apache.coyote.http11.upgrade

## Class NioServletInputStream

- java.lang.Object
- - java.io.InputStream
  - - javax.servlet.ServletInputStream
    - - org.apache.coyote.http11.upgrade.AbstractServletInputStream
      - - org.apache.coyote.http11.upgrade.NioServletInputStream

All Implemented Interfaces:
  Closeable, AutoCloseable

    public class NioServletInputStream
    extends AbstractServletInputStream

### Field Summary

### Fields inherited from class org.apache.coyote.http11.upgrade.AbstractServletInputStream

`sm`

### Constructor Summary

Constructors
Constructor and Description
`NioServletInputStream(SocketWrapper<NioChannel> wrapper, NioSelectorPool pool)`

### Method Summary

Methods
`protected void` `doClose()`
`protected boolean` `doIsReady()`
`protected int` `doRead(boolean block, byte[] b, int off, int len)` Abstract method to be overridden by concrete implementations.

### Methods inherited from class org.apache.coyote.http11.upgrade.AbstractServletInputStream

`close, isCloseRequired, isFinished, isReady, onDataAvailable, read, read, readLine, setReadListener`

### Methods inherited from class java.io.InputStream

`available, mark, markSupported, read, reset, skip`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### NioServletInputStream

    public NioServletInputStream(SocketWrapper<NioChannel> wrapper,
                         NioSelectorPool pool)

### Method Detail

#### doIsReady

    protected boolean doIsReady()
                         throws IOException

Specified by:
  `doIsReady` in class `AbstractServletInputStream`
Throws:
  `IOException`

#### doRead

    protected int doRead(boolean block,
             byte[] b,
             int off,
             int len)
                  throws IOException

Description copied from class: `AbstractServletInputStream`
Abstract method to be overridden by concrete implementations. The base class will ensure that there are no concurrent calls to this method for the same socket.

Specified by:
  `doRead` in class `AbstractServletInputStream`
Throws:
  `IOException`

#### doClose

    protected void doClose()
                    throws IOException

Specified by:
  `doClose` in class `AbstractServletInputStream`
Throws:
  `IOException`